; This file initialises and executes the gestures.  The compiled (exe) version
; does *not* read it - you will need AutoHotkey itself to create/modify the
; gestures.


; Make Send work quickly by default.
SetKeyDelay -1

return


; -----------------------------------------------------------------------------

Move_Action:
  WinGet pm,, ahk_class Progman
  if mg_aid = %pm%
    return

  WinGetPos x, y, w, h, A
  ; If the dimensions have been changed externally, reset the original position.
  if (p_i = mg_aid && (n_w <> w || n_h <> h))
    p_i =

  if mg_arg =
    goto move_dlg

  mg_arg1 := mg_arg2 := mg_arg3 := mg_arg4 := mg_arg5 := ""
  StringSplit mg_arg, mg_arg, `,

move_it:
  if (mg_arg1 = "W" && mg_aid = mg_cid)
    return
  if (mg_arg1 = "W" || (mg_aid <> mg_cid && mg_arg1 = "#" && mg_winkey))
    WinGetPos dx, dy, dw, dh, ahk_id %mg_cid%
  else
    WinGetPos dx, dy, dw, dh, ahk_class Progman
   do_move(mg_arg2, mg_arg4, x, w, dx, dw)
  ,do_move(mg_arg3, mg_arg5, y, h, dy, dh)
  ; Do the move and get the actual position set, in case the window manages its
  ; own size (like consoles).
  WinMove ahk_id %mg_aid%,, dx, dy, dw, dh
  WinGetPos dx, dy, dw, dh, ahk_id %mg_aid%
  ; If the window hasn't moved, restore the original position.
  if (mg_aid = p_i && x = dx && y = dy && w = dw && h = dh)
  {
    WinMove ahk_id %p_i%,, p_x, p_y, p_w, p_h
    p_i =
  }
  else if mg_aid <> %p_i%
  {
     p_i := mg_aid
    ,p_x := x
    ,p_y := y
    ,p_w := w
    ,p_h := h
  }
   n_w := dw
  ,n_h := dh
return


do_move(pos1, pos2, win_pos, win_dim, ByRef dst_pos, ByRef dst_dim)
{
  if SubStr(pos1, 1, 1) = "r"
  {
    pos1 := check_fraction(SubStr(pos1, 2))
    if pos2 =
      pos2 := pos1 * dst_dim
    else
      pos2 := make_relative(pos2, dst_pos, dst_pos, dst_dim, win_dim)
     dst_pos += Floor(pos2 - pos1 * win_dim)
    ,dst_dim := win_dim
  }
  else
  {
     pos1 := make_relative(pos1, win_pos, dst_pos, dst_dim, win_dim)
    ,pos2 := make_relative(pos2, win_pos + win_dim, dst_pos, dst_dim, win_dim)
    ,pos1 := make_size(pos1, win_pos, win_pos + win_dim + pos2, -win_dim)
    ,pos2 := make_size(pos2, win_pos + win_dim, win_pos + pos1, win_dim)
    if (pos1 > win_dim + pos2)
    {
      tmp := pos1
      ,pos1 := win_dim + pos2
      ,pos2 := tmp - win_dim
    }
     dst_pos := win_pos + pos1
    ,dst_dim := win_dim + pos2 - pos1
  }
}


make_relative(new_pos, cur_pos, dst_pos, dst_dim, src_dim)
{
  if new_pos =
    return 0

  if new_pos is digit
    return dst_pos + new_pos - cur_pos

  ; Negative numbers may be an absolute position (such as the current position
  ; of a maximized window) or a relative position (move back a bit).  I would
  ; expect the latter to be more common, so use a double sign for the former.
  beg := SubStr(new_pos, 1, 2)
  if beg in --,-+
    return dst_pos + SubStr(new_pos, 2) - cur_pos

  ; Use plus and a sign to take it relative to the opposing edge.
  if beg in +-,++
    return dst_pos + dst_dim + SubStr(new_pos, 2) - cur_pos

  beg := SubStr(beg, 1, 1)
  if beg in +,-
  {
    if new_pos is integer
      return new_pos
    return Floor(check_fraction(new_pos) * src_dim)
  }

  new_pos := check_fraction(new_pos)
  if new_pos is float
    return dst_pos + Floor(new_pos * dst_dim) - cur_pos

  return new_pos
}


make_size(sz, cur_pos, edge, dim)
{
  if SubStr(sz, 1, 1) != "="
    return sz

  sz := SubStr(sz, 2)
  if sz =
    sz := dim
  else
  {
    sz := check_fraction(sz)
    if sz is float
      sz := Floor(sz * dim)
    else if dim < 0
      sz := -sz
  }
  return edge + sz - cur_pos
}


; If it's of the form X/Y, calculate it ("1/3" is much nicer than "0.333333").
check_fraction(num)
{
  return RegExMatch(num, "^([+-]?[\d.,]+)/([\d.,]+)$", n) ? n1 / n2 : num
}


move_dlg:
  ; By default, edit controls are 15 times the font size - let's halve that.
  ; Since it doesn't seem possible to get the font size directly, create a dummy
  ; GUI to find it, rather than having to rely on pixels.  While I'm here, find
  ; the sizes of the labels & buttons to make them the same as the biggest.
  if ew =
  {
    Gui Add, Edit, VeLeft
    GuiControlGet w, Pos, eLeft
    ew := wW // 2

    Gui Add, Button, Vc1, %mg_sCurrent%
    Gui Add, Button, Vc2, %mg_sPrevious%
    Gui Add, Button, Vc3, %mg_sClear%
    Gui Add, Button, Vc4, %mg_sRetrieve%
    Loop 4
    {
      GuiControlGet w, Pos, c%A_Index%
      if wW > %cw%
	cw := wW
    }

    Gui Add, Button, Vb1, %mg_sOK%
    Gui Add, Button, Vb2, %mg_sCancel%
    GuiControlGet w, Pos, b1
    ow := wW
    GuiControlGet w, Pos, b2
    if wW > %ow%
      ow := wW

    Gui Add, Text, Vt1,  %mg_sLeft%
    Gui Add, Text, Vt2,  %mg_sTop%
    Gui Add, Text, Vt3,  %mg_sRight%
    Gui Add, Text, Vt4,  %mg_sBottom%
    Gui Add, Text, Vt5,  %mg_sHSrc%
    Gui Add, Text, Vt6,  %mg_sHDst%
    Gui Add, Text, Vt7,  %mg_sVSrc%
    Gui Add, Text, Vt8,  %mg_sVDst%
    Gui Add, Text, Vt9,  %mg_sWidth%
    Gui Add, Text, Vt10, %mg_sHeight%
    Loop 10
    {
      GuiControlGet w, Pos, t%A_Index%
      if wW > %lw%
	lw := wW
    }

    Gui Destroy
  }

  ; Chop off the title if it's a bit long.
  if StrLen(mg_atitle) > 80
    mg_atitle := SubStr(mg_atitle, 1, 80) "..."
  if StrLen(mg_ctitle) > 80
    mg_ctitle := SubStr(mg_ctitle, 1, 80) "..."

  Transform, mg_arg, Deref, %mg_sMove%
  Gui Add, Text,, %mg_arg%
  Gui Add, Text, W%lw% VtLeft section, %mg_sLeft%
  Gui Add, Text, W%lw% VtTop, %mg_sTop%
  Gui Add, Text, W%lw% VtRight, %mg_sRight%
  Gui Add, Text, W%lw% VtBottom, %mg_sBottom%
  Gui Add, Edit, gSetDims W%ew% VeLeft ys-4 section, %eLeft%
  Gui Add, Edit, gSetDims W%ew% VeTop, %eTop%
  Gui Add, Edit, gSetDims W%ew% VeRight, %eRight%
  Gui Add, Edit, gSetDims W%ew% VeBottom, %eBottom%
  if (mg_aid = mg_cid || mg_cid = pm)
    cbRelative = 0
  else
  {
    if mg_winkey
      mg_arg1 = Checked
    Transform, mg_arg2, Deref, %mg_sRelative%
    Gui Add, Checkbox, gSetDims_cb y+8 xm VcbRelative %mg_arg1%, %mg_arg2%
  }
  Gui Add, Button, y+10 w%ow% xs Default gMoveOK, %mg_sOK%
  Gui Add, Button, x+10 w%ow% gGuiClose, %mg_sCancel%
  Gui Add, Button, ys x+0 w%cw% VbCurrent GbCurrent, %mg_sCurrent%
  mg_arg := p_i <> mg_aid ? "Disabled" : ""
  Gui Add, Button, w%cw% VbPrevious GbPrevious %mg_arg%, %mg_sPrevious%
  Gui Add, Button, w%cw% VbClear GbClear, %mg_sClear%
  Gui Add, Text, % "VtDims Right w" ew " y+8 xp" cw - ew
  gosub SetDims
  Gui Show,, %mg_s1%
  mg_gui := true
return

bCurrent:
  from_button := 4
  if !retrieve_dims(bCurrent, mg_sCurrent)
    SetVals(x, y, w, h)
return

bPrevious:
  from_button := 4
  if !retrieve_dims(bPrevious, mg_sPrevious)
    SetVals(p_x, p_y, p_w, p_h)
return

SetVals(vx, vy, vw, vh)
{
  global

   vx -= ox
  ,vy -= oy
  ,SetPos(eLeft, vx)
  ,SetPos(eTop, vy)
  ,SetPos(eRight, vx + vw)
  ,SetPos(eBottom, vy + vh)
}

bClear:
  from_button := 4
  if !retrieve_dims(bClear, mg_sClear)
  {
    GuiControl,, eLeft
    GuiControl,, eTop
    GuiControl,, eRight
    GuiControl,, eBottom
  }
return

retrieve_dims(ByRef b, ByRef s)
{
  global
  local t

  GuiControlGet t,, b
  if t = %s%
  {
    if so =
    {
      GuiControlGet rLeft,,   eLeft
      GuiControlGet rTop,,    eTop
      GuiControlGet rRight,,  eRight
      GuiControlGet rBottom,, eBottom
    }
    else
    {
      if so = %mg_sCurrent%
	GuiControl,, bCurrent, %so%
      else if so = %mg_sPrevious%
	GuiControl,, bPrevious, %so%
      else ; so = %mg_sClear%
	GuiControl,, bClear, %so%
    }
    GuiControl,, b, %mg_sRetrieve%
    so := s
    return false
  }
  else
  {
    GuiControl,, eLeft,   %rLeft%
    GuiControl,, eTop,	  %rTop%
    GuiControl,, eRight,  %rRight%
    GuiControl,, eBottom, %rBottom%
    GuiControl,, b, %s%
    so =
    return true
  }
}

SetPos(ByRef e, d)
{
  if d < 0
    d = -%d%
  GuiControl,, e, %d%
}

SetDims_cb:
  mg_cb := -1
goto SetDims1

SetDims:
  ; There doesn't seem to be a way to distinguish between the user modifying the
  ; control and the script.  Since the script always modifies all four at once,
  ; just keep track of that.
  if mg_cb > 0
  {
    --mg_cb
    return
  }
  if from_button
  {
    --from_button
    if from_button
      return
  }
  else if so <>
  {
    ; A button was used to set all the values, which we're now modifying
    ; manually - cancel the retrieve.
    if so = %mg_sCurrent%
      GuiControl,, bCurrent, %so%
    else if so = %mg_sPrevious%
      GuiControl,, bPrevious, %so%
    else ; so = %mg_sClear%
      GuiControl,, bClear, %so%
    so =
  }

SetDims1:
  GuiControlGet mg_arg1,, cbRelative
  GuiControlGet mg_arg2,, eLeft
  GuiControlGet mg_arg3,, eTop
  GuiControlGet mg_arg4,, eRight
  GuiControlGet mg_arg5,, eBottom
  if mg_arg1
    WinGetPos dx, dy, dw, dh, ahk_id %mg_cid%
  else
    WinGetPos dx, dy, dw, dh, ahk_class Progman
   ox := dx
  ,oy := dy
  ,do_move(mg_arg2, mg_arg4, x, w, dx, dw)
  ,do_move(mg_arg3, mg_arg5, y, h, dy, dh)
  Transform d, Deref, %mg_sDims%
  GuiControl,, tDims, %d%

  if mg_cb
  {
    ; If the current or previous values have been set, adjust the positions to
    ; reflect the new origin.
    mg_cb := 4
    if so = %mg_sCurrent%
      SetVals(x, y, w, h)
    else if so = %mg_sPrevious%
      SetVals(p_x, p_y, p_w, p_h)
    else
      mg_cb := 0
  }

  if SubStr(mg_arg2, 1, 1) = "r"
  {
    GuiControl,, tLeft,  %mg_sHSrc%
    GuiControl,, tRight, %mg_sHDst%
  }
  else
  {
    GuiControl,, tLeft,  % SubStr(mg_arg2, 1, 1) = "=" ? mg_sWidth : mg_sLeft
    GuiControl,, tRight, % SubStr(mg_arg4, 1, 1) = "=" ? mg_sWidth : mg_sRight
  }
  if SubStr(mg_arg4, 1, 1) = "r"
  {
    GuiControl,, tTop,	  %mg_sVSrc%
    GuiControl,, tBottom, %mg_sVDst%
  }
  else
  {
    GuiControl,, tTop,	  % SubStr(mg_arg3, 1, 1) = "=" ? mg_sHeight : mg_sTop
    GuiControl,, tBottom, % SubStr(mg_arg5, 1, 1) = "=" ? mg_sHeight : mg_sBottom
  }
return

MoveOK:
  Gui Submit
  Gui Destroy
  mg_gui := false
  ,mg_arg1 := cbRelative ? "W" : ""
  ,mg_arg2 := eLeft
  ,mg_arg3 := eTop
  ,mg_arg4 := eRight
  ,mg_arg5 := eBottom
goto move_it


; -----------------------------------------------------------------------------

MinimizeAll_Action:
  WinMinimizeAll
return

RestoreAll_Action:
  WinMinimizeAllUndo
return


Maximize_Action:
  if mg_winkey
  {
    if mg_zoomed = 1
      WinRestore ahk_id %mg_cid%
    else
      WinMaximize ahk_id %mg_cid%
  }
  else
  {
    WinGet mg_zoomed, MinMax, A
    if mg_zoomed = 1
      WinRestore A
    else
      WinMaximize A
  }
return


Topmost_Action:
  if mg_winkey
    WinSet AlwaysOnTop, toggle, ahk_id %mg_cid%
  else
    WinSet AlwaysOnTop, toggle, A
return


PostWindow_Action:
  mg_arg1 := mg_arg2 := mg_arg3 := mg_arg4 := 0
  StringSplit mg_arg, mg_arg, `,
  if (mg_arg1 = "W" || (mg_arg1 = "#" && mg_winkey))
    PostMessage mg_arg2, mg_arg3, mg_arg4,, ahk_id %mg_cid%
  else
    PostMessage mg_arg2, mg_arg3, mg_arg4,, A
return


PostControl_Action:
  mg_arg1 := mg_arg2 := mg_arg3 := 0
  StringSplit mg_arg, mg_arg, `,
  PostMessage mg_arg1, mg_arg2, mg_arg3, %mg_control%, ahk_id %mg_cid%
return


Send_Action:
  if SubStr(mg_arg, 1, 1) = "{"
  {
    cb := InStr(mg_arg, "}")
    opt := cb = 2 ? 0 : SubStr(mg_arg, 2, cb - 2)
    if opt is digit
    {
      SetKeyDelay opt
      mg_arg := SubStr(mg_arg, cb + 1)
    }
    if SubStr(mg_arg, 1, 5) = "{Abs}"
      mg_arg := SubStr(mg_arg, 6)
    else
      CoordMode Mouse, Relative
  }
  Transform mg_arg, Deref, %mg_arg%
  Send %mg_arg%
  CoordMode Mouse, Screen
  SetKeyDelay -1
return


Run_Action:
  if SubStr(mg_arg, 1, 4) = "max "
  {
    mg_arg := SubStr(mg_arg, 5)
    ,mg_run := "Max"
  }
  else
    mg_run =
  Run %mg_arg%,, %mg_run% UseErrorLevel
  if ErrorLevel <> 0
  {
    Transform mg_run, Deref, %mg_sRunfail%
    MsgBox 0x10, %mg_s1%, %mg_run%
  }
return


; -----------------------------------------------------------------------------

Settings_Action:
  if mg_winkey
  {
    WinGetClass mg_aclass, ahk_id %mg_cid%
    Clipboard = title=%mg_ctitle%`nclass=%mg_aclass%`n
  }
  else
    Clipboard = title=%mg_atitle%`nclass=%mg_aclass%`n
  Run mg.ini
return


Configure_Action:
  ; Add a pattern to the excluded, disabled or mbutton lists.
  mg_title := mg_winkey ? mg_ctitle : mg_atitle
  ,mg_id := mg_winkey ? mg_cid : mg_aid
  WinGetPos,,, w, h, ahk_id %mg_id%
  DllCall("GetClientRect", "ptr", mg_id, "ptr", &rect)
  mg_autoexclude := (w = NumGet(rect, 8, "int") && h = NumGet(rect, 12, "int"))
  Gui Add, Text,, %mg_sConfig%
  Gui Add, Edit, Vmg_arg wp, ^%mg_title%$
  Gui Add, Checkbox, VcbExclude GcbExclude, % mg_autoexclude ? mg_sInclude : mg_sExclude
  Gui Add, Checkbox, VcbDisable GcbDisable, %mg_sDisable%
  Gui Add, Checkbox, VcbMiddle, %mg_sM0%
  Gui Add, Button, y+10 Default gConfigOK, %mg_sOK%
  Gui Add, Button, x+10 gGuiClose, %mg_sCancel%
  Gui Show,, %mg_s1%
  mg_gui := true
return

cbExclude:
  GuiControl,, cbDisable, 0
return

cbDisable:
  GuiControl,, cbExclude, 0
return

ConfigOK:
  Gui Submit
  Gui Destroy
  mg_gui := false

  if (mg_arg = "" || !valid_regex(mg_arg))
    return

  if (cbExclude || cbDisable)
  {
    ; If the title matches the new expression and it also matches the old, don't
    ; add it.  However, the new expression might not actually be for the title,
    ; so just add it if it doesn't match.
    if cbDisable
    {
      var := mg_disabled
      ,sect := "disabled"
      ,mg_err := 0
    }
    else if mg_autoexclude
    {
      var := mg_included
      ,sect := "included"
      ,mg_err := 1
    }
    else
    {
      var := mg_excluded
      ,sect := "excluded"
      ,mg_err := 2
    }
    if RegExMatch(mg_title, mg_arg) && RegExMatch(mg_title, var)
    {
      if (cbMiddle && RegExMatch(mg_title, mg_mbutton))
      {
	mg_err += 3
	cbMiddle = 0
      }
      Transform mg_err, Deref, % mg_sAlready%mg_err%
      MsgBox 0x40, %mg_s1%, %mg_err%
    }
    else
    {
      if var = (*FAIL)
	var := mg_arg
      else
	var .= "|" mg_arg
      IniWrite %var%, mg.ini, Settings, %sect%
      if cbDisable
	mg_disabled := var
      else if mg_autoexclude
	mg_included := var
      else
	mg_excluded := var
    }
  }
  if cbMiddle
  {
    if RegExMatch(mg_title, mg_arg) && RegExMatch(mg_title, mg_mbutton)
    {
      Transform mg_err, Deref, %mg_sAlready6%
      MsgBox 0x40, %mg_s1%, %mg_err%
    }
    else
    {
      if mg_mbutton = .^
	mg_mbutton := mg_arg
      else
	mg_mbutton .= "|" mg_arg
      IniWrite %mg_mbutton%, mg.ini, Settings, mbutton
    }
  }
return
